<script setup lang="ts">
  const mode = ref<'minimize' | 'standard' | 'expand'>('minimize');

  const { self, activeSpeaker, streamParticipants } = useParticipants();
  const el = ref<HTMLElement | null>(null);
  const { width, height } = useWindowSize();
  const delta = 6;
  const startX = ref();
  const startY = ref();
  const { x, y } = useDraggable(el, {
    initialValue: { x: 40, y: height.value - 120 },
  });
  const isDragging = ref<boolean>();
  const pressed = ref<boolean>();

  const handleStart = (event: any) => {
    startX.value = event.pageX || event.touches?.[0]?.pageX;
    startY.value = event.pageY || event.touches?.[0]?.pageY;
    pressed.value = true;
  };

  const handleHold = (event: any) => {
    if (!pressed.value) return;
    const diffX = Math.abs((event.pageX || event.touches?.[0]?.pageX) - startX.value);
    const diffY = Math.abs((event.pageY || event.touches?.[0]?.pageY) - startY.value);

    isDragging.value = diffX > delta || diffY > delta;

    if (isDragging.value) {
      event.preventDefault();
    }
  };

  const handleEnd = () => {
    startX.value = undefined;
    startY.value = undefined;
    isDragging.value = false;
    pressed.value = false;
  };

  const setMode = (v: 'minimize' | 'standard' | 'expand') => {
    mode.value = v;
  };

  const position = computed(() => {
    const maxHeight = height.value - 100;
    const maxWidth = width.value - 100;
    const top = y.value > 0 ? (y.value < maxHeight ? y.value : maxHeight) : 0;
    const left = x.value > 0 ? (x.value < maxWidth ? x.value : maxWidth) : 0;
    return {
      transform: `translate(${left}px, ${top}px)`,
    };
  });
</script>

<template>
  <div
    ref="el"
    :style="position"
    class="z-videoview fixed left-0 top-0 transform"
    @touchstart="handleStart"
    @touchmove="handleHold"
    @touchend="handleEnd"
    @mousedown="handleStart"
    @mousemove="handleHold"
    @mouseup="handleEnd"
  >
    <SwButton
      v-if="mode === 'minimize'"
      class="text-nowrap"
      :class="{
        'pointer-events-none': isDragging,
      }"
      variant="action"
      @click="setMode('standard')"
    >
      <template #icon>
        <span class="i-sw-solid:eye text-base"></span>
      </template>
      <span class="font-medium">{{ $t('presentation.showVideo') }}</span>
    </SwButton>
    <div
      v-if="['standard', 'expand'].includes(mode)"
      class="hover:(bg-background-dark bg-opacity-10) group absolute -bottom-[34px] left-0 cursor-pointer select-none rounded-lg p-2 transition"
      :class="{
        'w-60': mode === 'standard',
        'w-100': mode === 'expand',
      }"
    >
      <div class="mb-2 hidden justify-end gap-1.5 group-hover:flex">
        <SwButton
          :class="{
            'pointer-events-none': isDragging,
          }"
          variant="action"
          class="!p-2"
          @click="setMode('minimize')"
        >
          <span class="i-sw-solid:minus-s text-sm"></span>
        </SwButton>
        <SwButton
          v-if="mode === 'standard'"
          variant="action"
          class="!p-2"
          :class="{
            'pointer-events-none': isDragging,
          }"
          @click="setMode('expand')"
        >
          <span class="i-sw-solid:expand-arrows text-sm"></span>
        </SwButton>
        <SwButton
          v-if="mode === 'expand'"
          variant="action"
          class="!p-2"
          :class="{
            'pointer-events-none': isDragging,
          }"
          @click="setMode('standard')"
        >
          <span class="i-sw-solid:compress-arrows text-sm"></span>
        </SwButton>
      </div>
      <div class="flex flex-col gap-2">
        <SwVideoView
          v-if="activeSpeaker"
          :name="activeSpeaker?.data.user_name"
          :stream-src="activeSpeaker?.streams.video"
          :is-mute="!activeSpeaker?.streams.audio"
        >
          <template v-if="activeSpeaker?.data.owner" #icon>
            <div class="bg-primary rounded-md p-1.5">
              <span class="i-sw-solid:guide text-xs text-white" />
            </div>
          </template>
        </SwVideoView>
        <SwVideoView
          v-if="self"
          :name="self.attendeeName || self.attendeeId"
          :is-mute="!streamParticipants[self.videoUserId]?.streams.audio"
          :stream-src="streamParticipants[self.videoUserId]?.streams.video"
        >
          <template v-if="streamParticipants[self.videoUserId]?.data.owner" #icon>
            <div class="bg-primary rounded-md p-1.5">
              <span class="i-sw-solid:guide text-xs text-white" />
            </div>
          </template>
        </SwVideoView>
      </div>
    </div>
  </div>
</template>
